#include "stdafx.h"
#include <winsock2.h>
#include <process.h>		
#pragma comment(lib, "Ws2_32.lib")

static int threadCount = 0;
static SOCKET helloSock;
void myThread(void* thePtr);	// Forward declaration of thread method

int main(int argc, char* argv[])
{
	WSADATA wsaData; int err;
	if ((err = WSAStartup(MAKEWORD(2, 2), &wsaData)) != 0)
	{
		printf("Error in Winsock");
		return err;
	}

	helloSock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (helloSock == INVALID_SOCKET)
	{
		printf("Invalid Socket - error: %d", WSAGetLastError());
		return 0;
	}

	sockaddr_in hello_in;
	hello_in.sin_family = AF_INET;
	hello_in.sin_addr.s_addr = inet_addr("0.0.0.0");  // wildcard IP
	hello_in.sin_port = htons(4567);
	memset(hello_in.sin_zero, 0, sizeof(hello_in.sin_zero));

	if ((err = bind(helloSock, (SOCKADDR*)&hello_in, sizeof (hello_in))) != 0)
	{
		printf("Error in bind");
		return err;
	}

	if ((err = listen(helloSock, 5)) != 0)
	{
		printf("Error in listen");
		return err;
	}
	sockaddr_in	remote;	int	remote_len = sizeof(remote);

	while (true)
	{
		SOCKET sock = accept(helloSock, (SOCKADDR*)&remote, &remote_len);
		if (sock == INVALID_SOCKET)
		{
			printf("Invalid Socket - error: %d\n", WSAGetLastError() );
			break;
		}

		printf("Connected to IP: %s, port: %d\n", 
			   inet_ntoa(remote.sin_addr), remote.sin_port);

		threadCount++;
		_beginthread(myThread, 0, (void *)sock);
	}

	while (threadCount)
		Sleep(1000);

	printf("End of the line\n");
	WSACleanup();
	return 0;
}

void myThread(void* theSock)
{
	SOCKET sock = (SOCKET)theSock;
	char rcv[1000]; rcv[0] = '\0'; // Allocate buffer
	int offset = 0; int got;

	sockaddr_in	remote;
	int	remote_len = sizeof(remote);
	getpeername(sock, (SOCKADDR*)&remote, &remote_len);

	do // Build whole message if split in stream
	{  // 0: Untimely FIN received, <0: Error
		if ((got = recv(sock, &rcv[offset], sizeof(rcv)-1-offset, 0)) <= 0)
			break;
		offset += got;
		rcv[offset] = '\0'; // Terminate the string
		printf("Total String: %s\n", rcv);
	} while (!strstr(rcv, "\r\n\r\n")); // No body in GET
	// Create a HTML Message
	char msg[10000];

	int msglen = _snprintf_s(msg, sizeof(msg)-1, sizeof(msg),
		"<html><title>ElkHome</title><body>"
		"<h1>Welcome to Klaus Elk's Server</h1>"
		"<h2>You are: IP: %s, port: %d - %d'th thread, and you sent:"
		"<p>%s </p></h2>"
		"</body></html>",
		inet_ntoa(remote.sin_addr), remote.sin_port, threadCount, rcv);

	// Create a new header and send it before the message
	char header[1000];
	int headerlen = _snprintf_s(header, sizeof(header)-1, sizeof(header),
		"HTTP/1.1 200 OK\r\nContent-Length: %d\r\nContent-Type: " 
		"text/html\r\n\r\n", msglen);
	send(sock, header, headerlen, 0);

	// Now send the message
	send(sock, msg, msglen, 0);
	//	Sleep(10000);

	shutdown(sock, SD_SEND);
	closesocket(sock);
	threadCount--;

	if (strstr(rcv, "quit"))
		closesocket(helloSock);
}